/* MW.h */

/* Copyright(c) 1991-2006 by Motion Engineering, Inc.  All rights reserved.
 *
 * This software  contains proprietary and  confidential information  of
 * Motion Engineering Inc., and its suppliers.  Except as may be set forth
 * in the license agreement under which  this software is supplied, use,
 * disclosure, or  reproduction is prohibited without the prior express
 * written consent of Motion Engineering, Inc.
 */

/*
 *	RCSHeader
 */

#if !defined (__MEI_MW_H__)
#define __MEI_MW_H__

#if defined(__cplusplus)
extern "C" {
#endif

#if !defined (__DOUBLE_ALIGN_DEFS__)
#define __DOUBLE_ALIGN_DEFS__
#if defined(__GNUC__)
typedef	__attribute__ ((aligned(8))) double	DOUBLEA;
#else
typedef	double DOUBLEA;
#endif
#endif /* __DOUBLE_ALIGN_DEFS__ */

#define MEIXmpMW_VersionMAJOR					(3)
#define MEIXmpMW_VersionMINOR_REVISION			(2)
#define MEIXmpMW_VersionMINOR_SUB_REVISION		(9)
#define MEIXmpMW_Version						((MEIXmpMW_VersionMAJOR<<24) | (MEIXmpMW_VersionMINOR_REVISION<<16) | (MEIXmpMW_VersionMINOR_SUB_REVISION))

#define MEIXmpMAX_Models			MEIXmpMAX_Filters
#define	MEIXmpMaxObserverSize		(16)
#define	MEIXmpMaxFIRTapSize			(64)
#define	MEIXmpMaxBIQBlocks			(16)
#define	MEIXmpMaxSUMTerms			(8)
#define	MEIXmpBiQuadScale			(MEIXmpFRACTIONAL_UNITY)
/* This should go away with 03.05 */
#define MEIXmpMWFillerSize			((MEIXmpMAX_Filters * (sizeof(MEIXmpFilter)  + MEIXmpMaxGainTables * sizeof(MEIXmpFilterCoeff) - sizeof(MEIXmpMWModel))) / sizeof(long) - 1)
#define MEIXmpMWUserDataSize		(2)
#define MEIXmpMWBlockNameSize		(8)

#define	ModelCoeffPerSectionBIQ		(5)
#define	ModelDataPerSectionBIQ		(2)
#define ModelFixedRegistersBIQ		(3)

#define MEIXmpBIQCoeffSize			(ModelCoeffPerSectionBIQ + ModelDataPerSectionBIQ)
#define MEIXmpMaxDelaySize			(256)
#define MEIXmpMaxTestInputs			(16)
#define MEIXmpMaxTestOutputs		(16)
#define MEIXmpMaxTestPoints			(MEIXmpMaxTestInputs + MEIXmpMaxTestOutputs)
/* Only used for VM3 map */
#define MEIMapDataTypeDOUBLE0 MEIMapDataTypeDOUBLE
#define MEIMapDataTypeDOUBLE1 (MEIMapDataTypeLAST+1)

/* Add new blocks just before the model_list block */
typedef enum {
	MEIXmpMWBlockTypeINVALID = -1,		/* -1 */
	MEIXmpMWBlockTypeATAN,				/* 0  */
	MEIXmpMWBlockTypeBIQ,				/* 1  */
	MEIXmpMWBlockTypeBIQ_LOOKUP,		/* 2  */
	MEIXmpMWBlockTypeBROL,				/* 3  */
	MEIXmpMWBlockTypeCLIP,				/* 4  */
	MEIXmpMWBlockTypeCLIP2,				/* 5  */
	MEIXmpMWBlockTypeCOMP,				/* 6  */
	MEIXmpMWBlockTypeCONSTANT,			/* 7  */ 
	MEIXmpMWBlockTypeCOS,				/* 8  */
	MEIXmpMWBlockTypeDEADBAND,			/* 9  */
	MEIXmpMWBlockTypeDELAY,				/* 10 */
	MEIXmpMWBlockTypeDIFF,				/* 11 */
	MEIXmpMWBlockTypeDIV,	 			/* 12 */ 
	MEIXmpMWBlockTypeDTOF,				/* 13 */ 
	MEIXmpMWBlockTypeDTOI,				/* 14 */ 
	MEIXmpMWBlockTypeFTOD,				/* 15 */ 
	MEIXmpMWBlockTypeGAIN,				/* 16 */
	MEIXmpMWBlockTypeINTEGRATOR_R,		/* 17 */
	MEIXmpMWBlockTypeITOD,				/* 18 */
	MEIXmpMWBlockTypeLOOKUP,			/* 19 */
	MEIXmpMWBlockTypeLOOKUP2D,			/* 20 */
	MEIXmpMWBlockTypeMATRIXGAIN,		/* 21 */
	MEIXmpMWBlockTypeMODULO,			/* 22 */
	MEIXmpMWBlockTypeMSWITCH,			/* 23 */
	MEIXmpMWBlockTypeMULT,				/* 24 */
	MEIXmpMWBlockTypeNOISE,				/* 25 */
	MEIXmpMWBlockTypeOBS,				/* 26 */
	MEIXmpMWBlockTypeOUTPUT,			/* 27 */
	MEIXmpMWBlockTypePID_R,				/* 28 */
	MEIXmpMWBlockTypePIV_R,				/* 29 */
	MEIXmpMWBlockTypePOWER,				/* 30 */
	MEIXmpMWBlockTypeROL,				/* 31 */
	MEIXmpMWBlockTypeSELECTOR,			/* 32 */
	MEIXmpMWBlockTypeSIGN,				/* 33 */
	MEIXmpMWBlockTypeSIN,				/* 34 */
	MEIXmpMWBlockTypeSTATUS,			/* 35 */
	MEIXmpMWBlockTypeSUM,	 			/* 36 */
	MEIXmpMWBlockTypeSWITCH,			/* 37 */
	MEIXmpMWBlockTypeACTUAL,			/* 38 */
	MEIXmpMWBlockTypeCOMMAND,			/* 39 */
	MEIXmpMWBlockTypeERROR,				/* 40 */
	MEIXmpMWBlockTypeFEEDBACK,			/* 41 */
	MEIXmpMWBlockTypeFEEDBACK_VELOCITY,	/* 42 */
	MEIXmpMWBlockTypeMEMORY,			/* 43 */
	MEIXmpMWBlockTypeMEMORY_USER,		/* 44 */
	MEIXmpMWBlockTypeTCACCEL,			/* 45 */
	MEIXmpMWBlockTypeTCVEL,				/* 46 */
	MEIXmpMWBlockTypeTEST_IN,			/* 47 */
	MEIXmpMWBlockTypeMEMOUT,			/* 48 */
	MEIXmpMWBlockTypeMEMOUT_USER,		/* 49 */
	MEIXmpMWBlockTypeSCOPE,				/* 50 */
	MEIXmpMWBlockTypeTEST_OUT,			/* 51 */
	MEIXmpMWBlockTypePIV_GT,			/* 52 */
	MEIXmpMWBlockTypePID_GT,			/* 53 */
	MEIXmpMWBlockTypeGAININDEXT,		/* 54 */
	MEIXmpMWBlockTypeGAINSW,			/* 55 */
	MEIXmpMWBlockTypeWRAP_PIV_WITH_MAIN,/* 56 */
	MEIXmpMWBlockTypeWRAP_FB_PIV,		/* 57 */
	MEIXmpMWBlockTypeWRAP_FB_PID,		/* 58 */
	MEIXmpMWBlockTypeWRAP_STATUS,		/* 59 */
	MEIXmpMWBlockTypeWRAP_SIGN,			/* 60 */
	MEIXmpMWBlockTypeGAINSW2,			/* 61 */
	MEIXmpMWBlockTypeUSER_DEFINED,	/* 62 */
	MEIXmpMWBlockTypeMODEL_LIST,		/* 63 */
	

	MEIXmpMWBlockTypeLAST,				/* ?? */
} MEIXmpMWBlockType;

typedef enum {
	MEIXmpROL_OP_INVALID = -1,	/* -1 */
	MEIXmpROL_OP_GT,
	MEIXmpROL_OP_GE,
	MEIXmpROL_OP_EQ,
	MEIXmpROL_OP_NE,
	MEIXmpROL_OP_LE,
	MEIXmpROL_OP_LT,
} MEIXmpROL_OP;

typedef enum {
	MEIXmpBROL_OP_INVALID = -1,	/* -1 */
	MEIXmpBROL_OP_AND,
	MEIXmpBROL_OP_OR,
	MEIXmpBROL_OP_NAND,
	MEIXmpBROL_OP_NOR,
	MEIXmpBROL_OP_XOR,
} MEIXmpBROL_OP;

typedef enum {
	MEIXmpLookupTypeINVALID = -1,
	MEIXmpLookupTypeDIRECT,
	MEIXmpLookupTypeFIXED,
	MEIXmpLookupTypeVECTOR,
} MEIXmpLookupType;

typedef enum {
	MEIXmpDataTypeINVALID = -1,
	MEIXmpDataTypeFLOAT,
	MEIXmpDataTypeDOUBLE,
	MEIXmpDataTypeINT16,
	MEIXmpDataTypeINT32,
	MEIXmpDataTypeINT64,
} MEIXmpDataType;

typedef enum {
	MEIXmpStatusModeINVALID = -1,
	MEIXmpStatusModeDISABLE,
	MEIXmpStatusModeNORMAL,
	MEIXmpStatusModeCUSTOM,
	MEIXmpStatusModeP_PI,
} MEIXmpStatusMode;

/* For configuration software to work correctly the first word must be Output */
/* Maintain the same order for the block enum definitions above, and the block */ 
/* Structures that follow */

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;
} MEIXmpATANBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;
	long						Length;
	DOUBLEA						Coeff[1]; /* actual storage is allocated later */
} MEIXmpBIQBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;
	DOUBLEA						*LookupInput;	/* lookup input */
	long						Length;
	MEIXmpLookupType			LookupType;
	long						LookupTableSize;
	DOUBLEA						Coeff[1]; /* actual storage is allocated later */
} MEIXmpBIQ_LOOKUPBlock;

typedef struct {
	long						Output; /* must be first */
	long						*Input0;
	long						*Input1;
	MEIXmpBROL_OP				op;
} MEIXmpBROLBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;
	DOUBLEA						Limit;
	DOUBLEA						Offset;
} MEIXmpCLIPBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;
	DOUBLEA						UpperLimit;
	DOUBLEA						LowerLimit;
	DOUBLEA						Offset;
} MEIXmpCLIP2Block;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input0;
	DOUBLEA						*Input1;
} MEIXmpCOMPBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
} MEIXmpCONSTANTBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;
} MEIXmpCOSBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;
	DOUBLEA						UpperLimit;
	DOUBLEA						LowerLimit;
} MEIXmpDEADBANDBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;
	long						Delay;
	long						DelayIndex;
	long						MaxDelay;
	DOUBLEA						DelayBuffer[1]; /* actual storage is allocated later */
} MEIXmpDELAYBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;
	DOUBLEA						OldInput;
	DOUBLEA						Ksm;
} MEIXmpDIFFBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input0;
	DOUBLEA						*Input1;
} MEIXmpDIVBlock;

typedef struct {
	float						Output; /* must be first */
	DOUBLEA						*Input;
} MEIXmpDTOFBlock;

typedef struct {
	long						Output; /* must be first */
	DOUBLEA						*Input;
} MEIXmpDTOIBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	float						*Input;
} MEIXmpFTODBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;
	DOUBLEA						K;
} MEIXmpGAINBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;
	DOUBLEA						*Ki;
	DOUBLEA						*Limit;   /* Imax */
	DOUBLEA						*ResetInt; 
    DOUBLEA						sum;
} MEIXmpINTEGRATOR_RBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	long						*Input;
} MEIXmpITODBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;	/* lookup input */
	MEIXmpLookupType			LookupType;
	long						LookupTableSize;
	DOUBLEA						LookupTable[1];
} MEIXmpLOOKUPBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input0;	/* lookup input 0*/
	DOUBLEA						*Input1;	/* lookup input 1*/
	MEIXmpLookupType			LookupType;
	long						LookupTableRows;
	long						LookupTableCols;
	DOUBLEA						LookupTable[1];
} MEIXmpLOOKUP2DBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;
	long						Length;
	DOUBLEA						Coeff[MEIXmpMaxObserverSize];
} MEIXmpMATRIXGAINBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;
	long						Divisor;
} MEIXmpMODULOBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input0;
	DOUBLEA						*Input1;
	DOUBLEA						State;
} MEIXmpMSWITCHBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input0;
	DOUBLEA						*Input1;
} MEIXmpMULTBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						Kn1;
	DOUBLEA						Kn2;
} MEIXmpNOISEBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input0;
	DOUBLEA						*Input1;
	DOUBLEA						*Enable;
	long						Length;
	DOUBLEA						x[MEIXmpMaxObserverSize];
	DOUBLEA						Coeff[1]; /* actual storage is allocated later */
} MEIXmpOBSBlock;

typedef struct {
	float						Output; /* must be first */
	long						dummy;	/* Overwritten when double is converted to float */
	DOUBLEA						*Input;
} MEIXmpOUTPUTBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;
	DOUBLEA						*ResetInt; 
	DOUBLEA						*ResetIntValue; 
	DOUBLEA						Sum;
	DOUBLEA						OldInput;
	DOUBLEA						Delta;
	DOUBLEA						Kp;                    
	DOUBLEA						Ki;                    
	DOUBLEA						Kd;                     
	DOUBLEA						Ksm;                 
	DOUBLEA						IMax;            
} MEIXmpPID_RBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Inputp;
	DOUBLEA						*Inputv;
	DOUBLEA						*ResetIntp; 
	DOUBLEA						*ResetIntValuep; 
	DOUBLEA						*ResetIntv; 
	DOUBLEA						*ResetIntValuev; 
	DOUBLEA						Sump;
	DOUBLEA						Sumv;
	DOUBLEA						VPosition;
	DOUBLEA						VCommand;
	DOUBLEA						V;
	DOUBLEA						Kpp;
	DOUBLEA						Kip;
	DOUBLEA						Kpv;
	DOUBLEA						Kiv;
	DOUBLEA						Ksm;
	DOUBLEA						IMaxp;
	DOUBLEA						IMaxv;
} MEIXmpPIV_RBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;
	DOUBLEA						Exponent;
} MEIXmpPOWERBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input0;
	DOUBLEA						*Input1;
	MEIXmpROL_OP				op;
} MEIXmpROLBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input0;
	DOUBLEA						*Input1;
	DOUBLEA						*Selector;
} MEIXmpSELECTORBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;
} MEIXmpSIGNBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;
} MEIXmpSINBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	long						Axis;
	long						Enable;
} MEIXmpSTATUSBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input[MEIXmpMaxObserverSize];
	long						nSum;
	DOUBLEA						Coeff[MEIXmpMaxObserverSize];
} MEIXmpSUMBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input0;
	DOUBLEA						*Input1;
	DOUBLEA						*State;
} MEIXmpSWITCHBlock;

/* "Input" blocks. The code that uses these blocks is MW_MEMORY */

typedef struct {
	DOUBLEA						Output; /* must be first */
	MEIXmpDataType				DataType;
	void						*Input;
} MEIXmpACTUALBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	MEIXmpDataType				DataType;
	void						*Input;
} MEIXmpCOMMANDBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	MEIXmpDataType				DataType;
	void						*Input;
} MEIXmpERRORBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	MEIXmpDataType				DataType;
	void						*Input;
} MEIXmpFEEDBACKBlock;

typedef struct MEIXmpFEEDBACK_VELOCITYBlock {
	DOUBLEA						Output; /* must be first */
	long						OldInput;
	long						*Input;
} MEIXmpFEEDBACK_VELOCITYBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	MEIXmpDataType				DataType;
	void						*Input;
} MEIXmpMEMORYBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	MEIXmpDataType				DataType;
	void						*Input;
} MEIXmpMEMORY_USERBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	MEIXmpDataType				DataType;
	void						*Input;
} MEIXmpTCACCELBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	MEIXmpDataType				DataType;
	void						*Input;
} MEIXmpTCVELBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	MEIXmpDataType				DataType;
	void						*Input;
} MEIXmpTEST_INBlock;

/* "Output" blocks. The code that uses these blocks is MW_MEMOUT */

typedef struct {
	DOUBLEA						Output; /* must be first */
	MEIXmpDataType				DataType;
	DOUBLEA						*Input;
	void						*OutputPtr;
} MEIXmpMEMOUTBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	MEIXmpDataType				DataType;
	DOUBLEA						*Input;
	void						*OutputPtr;
} MEIXmpMEMOUT_USERBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	MEIXmpDataType				DataType;
	DOUBLEA						*Input;
	void						*OutputPtr;
} MEIXmpSCOPEBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	MEIXmpDataType				DataType;
	DOUBLEA						*Input;
	void						*OutputPtr;
} MEIXmpTEST_OUTBlock;

typedef struct {
	DOUBLEA						Output;					/* must be first */
	DOUBLEA						*Input;					/* position error */	
	DOUBLEA						*InputVelPos;			/* velocity position input */
	DOUBLEA						*GainIndex;
	long						AxisNumber;
	DOUBLEA						*ResetIntp; 
	DOUBLEA						*ResetIntv;
	DOUBLEA						PosErrorSum;
	DOUBLEA						PosErrorOld;
	DOUBLEA						InputVelPosOld;
	DOUBLEA						VelError;
	DOUBLEA						VelErrorSum;
	DOUBLEA						SmoothedVelocity;
	DOUBLEA						OldVelocity;
	DOUBLEA						PIDOutput;					/* = OutputPosMeas / Output after PID, not including any FF terms */
	DOUBLEA						PIVOutput;					/* = OutputVelMeas / Output after PIV, If PID alg, equals PIDOuput */
	DOUBLEA						Kpp[MEIXmpMaxGainTables];
	DOUBLEA						Kip[MEIXmpMaxGainTables];
	DOUBLEA						Kpv[MEIXmpMaxGainTables];
	DOUBLEA						Kpff[MEIXmpMaxGainTables];
	DOUBLEA						Kvff[MEIXmpMaxGainTables];
	DOUBLEA						Kaff[MEIXmpMaxGainTables];
	DOUBLEA						Kfff[MEIXmpMaxGainTables];
	DOUBLEA						MovingIMax[MEIXmpMaxGainTables];
	DOUBLEA						RestIMax[MEIXmpMaxGainTables];
	DOUBLEA						Kdv[MEIXmpMaxGainTables];
	DOUBLEA						OutputLimit[MEIXmpMaxGainTables];
	DOUBLEA						OutputLimitHigh[MEIXmpMaxGainTables];
	DOUBLEA						OutputLimitLow[MEIXmpMaxGainTables];
	DOUBLEA						OutputOffset[MEIXmpMaxGainTables];
	DOUBLEA						Kiv[MEIXmpMaxGainTables];
	DOUBLEA						VintMax[MEIXmpMaxGainTables];
	DOUBLEA						Ka0[MEIXmpMaxGainTables];
	DOUBLEA						Ka1[MEIXmpMaxGainTables];
	DOUBLEA						Ka2[MEIXmpMaxGainTables];
	DOUBLEA						*InputNoise;
	float						*OutputPosMeas;
	float						*OutputVelMeas;
} MEIXmpPIV_GTBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;
	DOUBLEA						*GainIndex;
	long						AxisNumber;
	DOUBLEA						*ResetIntp;
	DOUBLEA						PosErrorSum;
	DOUBLEA						PosErrorOld;
	DOUBLEA						OldVelocity;
	DOUBLEA						Delta;
	DOUBLEA						Kp[MEIXmpMaxGainTables];
	DOUBLEA						Ki[MEIXmpMaxGainTables];
	DOUBLEA						Kd[MEIXmpMaxGainTables];
	DOUBLEA						Kpff[MEIXmpMaxGainTables];
	DOUBLEA						Kvff[MEIXmpMaxGainTables];
	DOUBLEA						Kaff[MEIXmpMaxGainTables];
	DOUBLEA						Kfff[MEIXmpMaxGainTables];
	DOUBLEA						MovingIMax[MEIXmpMaxGainTables];
	DOUBLEA						RestIMax[MEIXmpMaxGainTables];
	DOUBLEA						Ksm[MEIXmpMaxGainTables];
	DOUBLEA						OutputLimit[MEIXmpMaxGainTables];
	DOUBLEA						OutputLimitHigh[MEIXmpMaxGainTables];
	DOUBLEA						OutputLimitLow[MEIXmpMaxGainTables];
	DOUBLEA						OutputOffset[MEIXmpMaxGainTables];
} MEIXmpPID_GTBlock;

/* Custom blocks */
/* Move to FDK in the future? */
typedef struct {
	DOUBLEA					Output; /* must be first */
	DOUBLEA					*Input;
	DOUBLEA					Coeff[MEIXmpMaxGainTables]; 
} MEIXmpGAININDEXTBlock;

typedef struct {
	DOUBLEA					Output; /* must be first */
	long					AxisNumber;
	long					GainSwitchType;
	long					GainDelay;
	long					GainWindow;
	long					GainDelayCount; 
} MEIXmpGAINSWBlock;

typedef struct {
	DOUBLEA					Output; /* must be first */
	DOUBLEA					*Input;	/* not use */
	DOUBLEA					*VelPos;
	DOUBLEA					*GainIndex;
	long					AxisNumber;
	DOUBLEA					*ResetIntp; 
	DOUBLEA					*ResetIntValuep; 
	DOUBLEA					*ResetIntv; 
	DOUBLEA					*ResetIntValuev; 
	DOUBLEA					Kpp[MEIXmpMaxGainTables];
	DOUBLEA					Kip[MEIXmpMaxGainTables];
	DOUBLEA					Kpv[MEIXmpMaxGainTables];
	DOUBLEA					Kiv[MEIXmpMaxGainTables];
	DOUBLEA					Kvff[MEIXmpMaxGainTables];
	DOUBLEA					Kaff[MEIXmpMaxGainTables];
	DOUBLEA					Kfff[MEIXmpMaxGainTables];
	DOUBLEA					Ka1[MEIXmpMaxGainTables];
	DOUBLEA					MovingIMax[MEIXmpMaxGainTables];
	DOUBLEA					RestIMax[MEIXmpMaxGainTables];
	DOUBLEA					VintMax[MEIXmpMaxGainTables];
	DOUBLEA					Ksm;
	DOUBLEA					PosErrorSum;
	DOUBLEA					VelErrorSum;
	DOUBLEA					OldVelocity;
	DOUBLEA					VelPosition;
	DOUBLEA					Kfff_sign;
	DOUBLEA					VelSmoothCoeff[3];
	DOUBLEA					VelSmoothData[4];
	long					Length;		/* biquad stage */
	DOUBLEA					Coeff[1];	/* actual storage is allocated later */
} MEIXmpWRAP_PIVMainBlock;

typedef struct {
	DOUBLEA					Output; /* must be first */
	DOUBLEA					*Input;	
	DOUBLEA					*avInput;
	DOUBLEA					*VelFFInput;
	DOUBLEA					*GainIndex;
	long					AxisNumber;
	DOUBLEA					*ResetIntp; 
	DOUBLEA					*ResetIntValuep; 
	DOUBLEA					*ResetIntv; 
	DOUBLEA					*ResetIntValuev; 
	DOUBLEA					Kpp[MEIXmpMaxGainTables];
	DOUBLEA					Kip[MEIXmpMaxGainTables];
	DOUBLEA					Kpv[MEIXmpMaxGainTables];
	DOUBLEA					Kiv[MEIXmpMaxGainTables];
	DOUBLEA					MovingIMax[MEIXmpMaxGainTables];
	DOUBLEA					RestIMax[MEIXmpMaxGainTables];
	DOUBLEA					VintMax[MEIXmpMaxGainTables];
	DOUBLEA					Ksm;
	DOUBLEA					PosErrorSum;
	DOUBLEA					VelErrorSum;
	DOUBLEA					OldVelocity;
} MEIXmpWRAP_FB_PIVBlock;

typedef struct {
	DOUBLEA					Output; /* must be first */
	DOUBLEA					*Input;	/* not use */
	DOUBLEA					*GainIndex;
	long					AxisNumber;
	DOUBLEA					*ResetIntp; 
	DOUBLEA					*ResetIntValuep; 
	DOUBLEA					Kp[MEIXmpMaxGainTables];
	DOUBLEA					Ki[MEIXmpMaxGainTables];
	DOUBLEA					Kd[MEIXmpMaxGainTables];
	DOUBLEA					MovingIMax[MEIXmpMaxGainTables];
	DOUBLEA					RestIMax[MEIXmpMaxGainTables];
	DOUBLEA					Ksm;
	long					DRate;                 
	DOUBLEA					ErrorSum;
	DOUBLEA					ErrorDelta;
	DOUBLEA					OldError;
	DOUBLEA					OldVelocity;
	DOUBLEA					DerivFilter[MEIXmpDFilterSize];
} MEIXmpWRAP_FB_PIDBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	long						Axis;
	MEIXmpStatusMode			Mode;
	MEIXmpIntResetStatus		RINTStatus;
	MEIXmpPPIMode				PPIStatus;
	MEIXmpSwitchType			PPISwitchType;
	long						PPIWindow;
	long						Delay;
	long						DelayCount;
} MEIXmpWRAP_STATUSBlock;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input;	/* not use */
	long						Axis;
	DOUBLEA						sign;
} MEIXmpWRAP_SIGNBlock;

typedef struct {
	DOUBLEA					Output; /* must be first */
	long					AxisNumber;
	long					Enable;
	DOUBLEA					Position[4];
} MEIXmpGAINSW2Block;

typedef struct {
	DOUBLEA						Output; /* must be first */
	DOUBLEA						*Input[MEIXmpMaxObserverSize];
	DOUBLEA						Coeff[MEIXmpMaxObserverSize];
} MEIXmpUSER_DEFINEDBlock;

/* Dummy block. Never appears in model's step list. */

typedef struct {
	DOUBLEA						Output; /* must be first */
} MEIXmpMODEL_LISTBlock;

/* Note: this block must be after the Block definitions for the 
VM3 MechaWare label parser (xmpMWMap.exe) to work correctly. */
typedef struct {
	long				UserData[MEIXmpMWUserDataSize];
	long				BlockName[MEIXmpMWBlockNameSize];
} MEIXmpMWProgramUser;

typedef struct {
	MEIXmpMWBlockType	BlockType;
	void				*BlockPtr;
	long				SubSampleMask;
} MEIXmpMWProgram;

typedef struct {
	MEIXmpAlgorithm			Algorithm;
	float					ControlOutput;
	long					Steps;
	MEIXmpStatus			Status;
	long					SubSample;
	MEIXmpMWProgram			*Program;
	long					Size;
} MEIXmpMWModel;

/* for map module to work correctly the MechaWare and Standard algorithm structures must be the same size */
#define MWReserved ((sizeof(MEIXmpStandardAlgorithm) - (sizeof(MEIXmpMWModel) * MEIXmpMAX_Models + sizeof(long) * MEIXmpMWFillerSize))/sizeof(long))

typedef struct {
	MEIXmpMWModel	Model[MEIXmpMAX_Models];
	long			Filler[MEIXmpMWFillerSize];
	long			Reserved[MWReserved];
} MEIXmpMWAlgorithm;

#if defined(__cplusplus)
}
#endif

#endif /* __MEI_MW_H__ */
