//SIMLib.h

/* Copyright(c) 1991-2006 by Motion Engineering, Inc.  All rights reserved.
 *
 * This software  contains proprietary and  confidential information  of
 * Motion Engineering Inc., and its suppliers.  Except as may be set forth
 * in the license agreement under which  this software is supplied, use,
 * disclosure, or  reproduction is prohibited without the prior express
 * written consent of Motion Engineering, Inc.
 */


#if !defined __SIMLIB_H__
#define __SIMLIB_H__

#if defined(__cplusplus)
extern "C" {
#endif

typedef struct {
	char*			base;
	unsigned long	size;
} MemorySegment;

typedef struct {
	long			segments;
	MemorySegment	segment[10];
} MemoryMap;

void		SimStart(void);
void		SimStop(void);
void		SimReset(void);
HANDLE		SimEvent(void);
HANDLE		GoEvent(void);
MemoryMap*	SimMemory(void);
long		SimError(void);
void		SimWake(void);
void        SimIo(void);
double      SimSpeed(void);
void        SimSpeedGet(double* speed);
void		Delay(long delay);
void		SimVersion(char *version);

#include "Xmp.h"

typedef enum SimIoState
{
	  SimIoStateIDLE
	, SimIoStateUSER_UPDATE
	, SimIoStateFW_UPDATE_REQUEST
	, SimIoStateFW_UPDATE

} SimIoState;

typedef struct MotorIoSim
{
	unsigned long	ActualEqCommand;
	unsigned long	DedicatedInAndMask;
	unsigned long	DedicatedInOrMask;
	unsigned long	GeneralInAndMask;
	unsigned long	GeneralInOrMask;

	long		AuxEncoder[MEIXmpMotorEncoders];
	/* Monitors */
	union
	{
		struct
		{
			short MonitorA;
			short MonitorB;
		};
		unsigned long MonitorAB;
	};
	union
	{
		struct
		{
			short MonitorC;
			short MonitorD;
		};
		unsigned long MonitorCD;
	};

	/* model params */
	double inv_inertia;
	double viscocity;
	double friction;
	double kinetic_friction;
	double static_friction;
	double force;
} MotorIoSim;

typedef struct SimMemMap
{
	MotorIoSim motorIo[MEIXmpMAX_Motors];

	double	   simSpeed;
	SimIoState simIo;
} SimMemMap;

extern SimMemMap* simMemMap;
#if defined(__cplusplus)
}
#endif

#endif