/* eventmgr.h */

/* Copyright(c) 1991-2006 by Motion Engineering, Inc.  All rights reserved.
 *
 * This software  contains proprietary and  confidential information  of
 * Motion Engineering Inc., and its suppliers.  Except as may be set forth
 * in the license agreement under which  this software is supplied, use,
 * disclosure, or  reproduction is prohibited without the prior express
 * written consent of Motion Engineering, Inc.
 */

/*
 *	RCSHeader
 */

#if !defined(_EVENTMGR_H)
#define	_EVENTMGR_H

/* EventMgr handle */
#if defined(__cplusplus)
extern "C" {
#endif
typedef struct _MPIEventMgr *MPIEventMgr;
#if defined(__cplusplus)
}
#endif

#include "mpidef.h"
#include "control.h"
#include "event.h"
#include "notify.h"

#if defined(__cplusplus)
extern "C" {
#endif

typedef MPIEmpty	MPIEventMgrConfig;

typedef enum {
	MPIEventMgrMessageFIRST = mpiMessageID(MPIModuleIdEVENTMGR, 0),

	MPIEventMgrMessageEVENTMGR_INVALID,

	MPIEventMgrMessageLAST
} MPIEventMgrMessage;

/* Create/Delete/Validate */
MPI_DECL1 MPIEventMgr MPI_DECL2
	mpiEventMgrCreate(MPIControl control);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrDelete(MPIEventMgr eventMgr);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrValidate(MPIEventMgr eventMgr);

/* EventMgr */
MPI_DECL1 long MPI_DECL2
	mpiEventMgrConfigGet(MPIEventMgr		eventMgr,
						 MPIEventMgrConfig	*config,
						 void				*external);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrConfigSet(MPIEventMgr		eventMgr,
						 MPIEventMgrConfig	*config,
						 void				*external);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrEvent(MPIEventMgr	eventMgr,
					 MPIEventStatus	*status);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrFlashConfigGet(MPIEventMgr		eventMgr,
							  void				*flash,
							  MPIEventMgrConfig	*config,
							  void				*external);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrFlashConfigSet(MPIEventMgr		eventMgr,
							  void				*flash,
							  MPIEventMgrConfig	*config,
							  void				*external);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrFlush(MPIEventMgr eventMgr);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrService(MPIEventMgr	eventMgr,
					   MPIControl	control);

/* List */
MPI_DECL1 MPIControl MPI_DECL2
	mpiEventMgrControl(MPIEventMgr	eventMgr,
					   long			index);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrControlAppend(MPIEventMgr	eventMgr,
							 MPIControl		control);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrControlCount(MPIEventMgr eventMgr);

MPI_DECL1 MPIControl MPI_DECL2
	mpiEventMgrControlFirst(MPIEventMgr eventMgr);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrControlIndex(MPIEventMgr	eventMgr,
							MPIControl	control);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrControlInsert(MPIEventMgr	eventMgr,
							 MPIControl		control,
							 MPIControl		insert);

MPI_DECL1 MPIControl MPI_DECL2
	mpiEventMgrControlLast(MPIEventMgr eventMgr);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrControlListGet(MPIEventMgr	eventMgr,
							  long			*controlCount,
							  MPIControl	*controlList);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrControlListSet(MPIEventMgr	eventMgr,
							  long			controlCount,
							  MPIControl	*controlList);

MPI_DECL1 MPIControl MPI_DECL2
	mpiEventMgrControlNext(MPIEventMgr	eventMgr,
						   MPIControl	control);

MPI_DECL1 MPIControl MPI_DECL2
	mpiEventMgrControlPrevious(MPIEventMgr	eventMgr,
							   MPIControl	control);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrControlRemove(MPIEventMgr	eventMgr,
							 MPIControl		control);

MPI_DECL1 MPINotify MPI_DECL2
	mpiEventMgrNotify(MPIEventMgr	eventMgr,
					  long			index);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrNotifyAppend(MPIEventMgr	eventMgr,
							MPINotify	notify);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrNotifyCount(MPIEventMgr eventMgr);

MPI_DECL1 MPINotify MPI_DECL2
	mpiEventMgrNotifyFirst(MPIEventMgr eventMgr);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrNotifyIndex(MPIEventMgr	eventMgr,
						   MPINotify	notify);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrNotifyInsert(MPIEventMgr	eventMgr,
							MPINotify	notify,
							MPINotify	insert);

MPI_DECL1 MPINotify MPI_DECL2
	mpiEventMgrNotifyLast(MPIEventMgr eventMgr);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrNotifyListGet(MPIEventMgr	eventMgr,
							 long			*notifyCount,
							 MPINotify		*notifyList);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrNotifyListSet(MPIEventMgr	eventMgr,
							 long			notifyCount,
							 MPINotify		*notifyList);

MPI_DECL1 MPINotify MPI_DECL2
	mpiEventMgrNotifyNext(MPIEventMgr	eventMgr,
						  MPINotify		notify);

MPI_DECL1 MPINotify MPI_DECL2
	mpiEventMgrNotifyPrevious(MPIEventMgr	eventMgr,
							  MPINotify		notify);

MPI_DECL1 long MPI_DECL2
	mpiEventMgrNotifyRemove(MPIEventMgr	eventMgr,
							MPINotify	notify);

#if defined(__cplusplus)
}
#endif

#endif
