/* object.h */

/* Copyright(c) 1991-2006 by Motion Engineering, Inc.  All rights reserved.
 *
 * This software  contains proprietary and  confidential information  of
 * Motion Engineering Inc., and its suppliers.  Except as may be set forth
 * in the license agreement under which  this software is supplied, use,
 * disclosure, or  reproduction is prohibited without the prior express
 * written consent of Motion Engineering, Inc.
 */

/*
 *	RCSHeader
 */

#if !defined(_OBJECT_H)
#define _OBJECT_H

/* Object handle */
#if defined(__cplusplus)
extern "C" {
#endif
typedef void *MPIHandle;
#if defined(__cplusplus)
}
#endif

#include "mpidef.h"

#if defined(__cplusplus)
extern "C" {
#endif

/* Invalid handle */
#define	MPIHandleVOID	(NULL)

typedef	unsigned long	MPIObjectMap;

#define	mpiObjectMapAND_ASSIGN(dst,src)	((dst) &= (src))
#define	mpiObjectMapASSIGN(dst,src)		((dst) = (src))
#define	mpiObjectMapCLEAR(objectMap)	((objectMap) = 0x0)
#define	mpiObjectMapCOMPLEMENT(objectMap)	((objectMap) = ~(objectMap))
#define	mpiObjectMapMAX(objectMap,count)	((objectMap) = (0x1 << (count)) - 1)
#define	mpiObjectMapOR_ASSIGN(dst,src)	((dst) |= (src))

#define	mpiObjectMapIS_CLEAR(objectMap)	((objectMap) == 0x0)
#define	mpiObjectMapIS_EQUAL(map1,map2)	((map1) == (map2))
#define	mpiObjectMapIS_VALID(objectMap,count) \
										(((count) >= (sizeof(objectMap) * 8)) || \
										(((~((0x1 << (count)) - 1)) & (objectMap)) == 0))

#define	mpiObjectMapBitCountMAX(objectMap)	(sizeof(objectMap) * 8)
#define	mpiObjectMapBitGET(objectMap,bit)	(((objectMap) &  (0x1 << (bit))) ? 1 : 0)
#define	mpiObjectMapBitSET(objectMap,bit,value) \
										(((value) == 0) \
												? ((objectMap) &= ~(0x1 << (bit))) \
												: ((objectMap) |=  (0x1 << (bit))))

MPI_DECL1 long MPI_DECL2
	mpiObjectModuleId(MPIHandle		handle,
					  MPIModuleId	*moduleId);

MPI_DECL1 long MPI_DECL2
	mpiObjectTimeoutGet(MPIHandle	handle,
						MPIWait		*timeout);

MPI_DECL1 long MPI_DECL2
	mpiObjectTimeoutSet(MPIHandle	handle,
						MPIWait		timeout);

MPI_DECL1 long MPI_DECL2
	mpiObjectValidate(MPIHandle		handle,
					  MPIModuleId	moduleId);

MPI_DECL1 long MPI_DECL2
	mpiObjectMapBitCount(MPIObjectMap	objectMap);

#if defined(__cplusplus)
}
#endif

#endif
