/* server.h */

/* Copyright(c) 1991-2006 by Motion Engineering, Inc.  All rights reserved.
 *
 * This software  contains proprietary and  confidential information  of
 * Motion Engineering Inc., and its suppliers.  Except as may be set forth
 * in the license agreement under which  this software is supplied, use,
 * disclosure, or  reproduction is prohibited without the prior express
 * written consent of Motion Engineering, Inc.
 */

/*
 *	RCSHeader
 */

#if !defined(_SERVER_H)
#define	_SERVER_H

#if defined(__cplusplus)
extern "C" {
#endif
typedef struct _MEIServer *MEIServer;
#if defined(__cplusplus)
}
#endif

#include "meidef.h"
#include "packet.h"

#if defined(__cplusplus)
extern "C" {
#endif

typedef enum {
	MEIServerMessageFIRST = mpiMessageID(MEIModuleIdSERVER, 0),

	MEIServerMessageSERVER_INVALID,
	MEIServerMessageMETHOD_INVALID,
	MEIServerMessageHEADER_INVALID,

	MEIServerMessageLAST
} MEIServerMessage;

typedef enum {
	MEIServerTraceFIRST = MEITraceLAST << 1,

	MEIServerTraceLAST  = MEIServerTraceFIRST << 1
} MEIServerTrace;

/* Create/Delete/Validate */
MPI_DECL1 MEIServer MPI_DECL2
	meiServerCreate(MPIControl	control,
					MEIPacket	packet,
					long		port);

MPI_DECL1 long MPI_DECL2
	meiServerDelete(MEIServer	server);

MPI_DECL1 long MPI_DECL2
	meiServerValidate(MEIServer	server);

/* Server */
MPI_DECL1 MPIControl MPI_DECL2
	meiServerControl(MEIServer	server);

MPI_DECL1 MEIPacket MPI_DECL2
	meiServerPacket(MEIServer	server);

MPI_DECL1 long MPI_DECL2
	meiServerPort(MEIServer	server);

MPI_DECL1 MEIPacket MPI_DECL2
	meiServerClientPacket(MEIServer	server);

MPI_DECL1 long MPI_DECL2
	meiServerError(MEIServer	server,
				   long			*error);

MPI_DECL1 long MPI_DECL2
	meiServerMethod(MEIServer server);

#if defined(__cplusplus)
}
#endif

#endif
